package com.isu.gaswellwatch.modbus.data.listener;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.core.BatchMessageListener;
import org.springframework.amqp.core.Message;

import java.util.List;

@Slf4j
@RequiredArgsConstructor
public class BusinessMessageHandlerListener implements BatchMessageListener {
    @Override
    public void onMessage(Message message) {
        this.onMessageBatch(List.of(message));
    }

    @Override
    public void onMessageBatch(List<Message> messages) {

        //读取全部提醒字段的配置

        for (Message message : messages) {
            String messageString = new String(message.getBody());
            log.info("收到业务消息:{}", messageString);
            JSONObject messageObject= JSON.parseObject(messageString);
            if(messageObject.containsKey("old")){
                JSONObject oldObject = messageObject.getJSONObject("old");
                JSONObject newObject = messageObject.getJSONObject("new");
                String deviceId = oldObject.getString("deviceId");
                //TODO
                //根据设备ID获取设备的产品类型

                //根据对应的产品类型，用对应的气井开关字段获取开关状态(wellStatus,solenoidValveStatus,firstSolenoidStatus)

                //比对新旧数据，看开关状态是否一致

                //根据ID找到对应的提醒字段配置

                //遍历该id下的所有字段的配置，检查新消息中字段的值是否符合提醒条件


            }

        }

        //若不一致则批量记录设备操作日志

        //如果提醒数据不为空，批量保存提醒记录
    }
}
